/*
 * @(#)MockComponentTransferable.java
 *
 * Copyright (c) 2008 Jeremy Wood. All Rights Reserved.
 *
 * You have a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) You do not utilize the software in a manner
 * which is disparaging to the original author.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. THE AUTHOR SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL THE
 * AUTHOR BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 */
package com.bric.swing.toolbar;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;

import com.bric.swing.MockComponent;

/** A Transferable the encapsulates a MockComponent.
 * <P>This really isn't specifically necessary, but SOME transferable is.
 * And that transferable needs to <i>not</i> be text, or an image,
 * because then other eager apps would try to work with it.
 *
 */
class MockComponentTransferable implements Transferable {
	DataFlavor myDataFlavor;
	MockComponent mockComponent;
	public MockComponentTransferable(MockComponent mc) {
		try {
			myDataFlavor = new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType);
		} catch (ClassNotFoundException e) {
			RuntimeException e2 = new RuntimeException();
			e2.initCause(e);
			throw e2;
		}
		this.mockComponent = mc;
	}
	
	public Object getTransferData(DataFlavor flavor)
			throws UnsupportedFlavorException {
		if(flavor.equals(myDataFlavor)) {
			return mockComponent;
		} else {
			throw new UnsupportedFlavorException(flavor);
		}
	}
	

	public DataFlavor[] getTransferDataFlavors() {
		return new DataFlavor[] { myDataFlavor };
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		DataFlavor[] flavors = getTransferDataFlavors();
		for(int a = 0; a<flavors.length; a++) {
			if(flavors[a].equals(flavor))
				return true;
		}
		return false;
	}
}